<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/langref.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'ru',
  ),
  'this' => 
  array (
    0 => 'language.fibers.php',
    1 => 'Fibers',
  ),
  'up' => 
  array (
    0 => 'langref.php',
    1 => 'Справочник языка',
  ),
  'prev' => 
  array (
    0 => 'language.exceptions.extending.php',
    1 => 'Наследование исключений',
  ),
  'next' => 
  array (
    0 => 'language.generators.php',
    1 => 'Генераторы',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'ru',
    'path' => 'language/fibers.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.fibers" class="chapter">
 <h1 class="title">Fibers</h1>


 <div class="simplesect" id="language.fibers.overview">
  <h3 class="title">Обзор файберов</h3>
  <p class="verinfo">(PHP 8 &gt;= 8.1.0)</p>
  <p class="para">
   Файберы — механизм управления функциями, который умеет прерывать выполнение функций с сохранением полного внутреннего стека вызовов.
   Файберы разрешается приостанавливать в произвольном месте внутреннего стека вызовов, при этом выполнение кода внутри файбера
   приостанавливается, пока файбер не возобновит работу.
  </p>
  <p class="para">
   Файберы приостанавливают весь внутренний стек выполнения, поэтому коду, который работает с файберами,
   не придётся изменять логику вызова методов файбера (тогда как в других языках программирования
   при взаимодействии с асинхронными сопрограммами вызывающий код вынужденно изменяет способ вызова функций — прим. перев.).
  </p>
  <p class="para">
   Выполнение файбера разрешается прерывать методом <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> в произвольном месте стека вызовов,
   вызвать метод <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> можно в глубоко вложенной функции
   или не вызывать вовсе.
  </p>
  <p class="para">
   В отличие от бесстековых <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span>&#039;ов, под каждый <span class="classname"><a href="class.fiber.php" class="classname">Fiber</a></span>
   внутренне выделяется отдельный стек вызовов, что разрешает приостанавливать стеки внутри глубоко вложенных вызовов функций.
   Функция, которая вызовом метода <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span> объявляет точку прерывания файбера,
   не изменяет тип значения, которое она возвращает, в отличие от функций, которые содержат ключевое слово <a href="language.generators.syntax.php#control-structures.yield" class="link"><code class="literal">yield</code></a>
   и потому возвращают экземпляр класса <span class="classname"><a href="class.generator.php" class="classname">Generator</a></span>.
  </p>
  <p class="para">
   Приостановка файберов доступна как в пользовательских функциях, так и в функциях,
   которые вызываются внутри виртуальной машины языка PHP, наподобие callback-функции,
   которую передают как аргумент функции <span class="function"><a href="function.array-map.php" class="function">array_map()</a></span>, или методов, которые цикл <a href="control-structures.foreach.php" class="link"><code class="literal">foreach</code></a>
   вызывает на объекте класса <span class="classname"><a href="class.iterator.php" class="classname">Iterator</a></span>.
  </p>
  <p class="para">
   Выполнение приостановленного файбера возобновляют либо вызовом метода <span class="methodname"><a href="fiber.resume.php" class="methodname">Fiber::resume()</a></span>,
   который умеет передавать в точку приостановки файбера произвольное значение, либо вызовом метода <span class="methodname"><a href="fiber.throw.php" class="methodname">Fiber::throw()</a></span>,
   который передаёт исключение в ту же точку. При возобновлении работы файбера с передачей значения это значение
   возвращается в точке прерывания файбера как результат вызова метода <span class="methodname"><a href="fiber.suspend.php" class="methodname">Fiber::suspend()</a></span>,
   а при передаче исключения — файбер возобновляет выполнение в той же точке и выбрасывает это исключение.
  </p>

  <blockquote class="note"><p><strong class="note">Замечание</strong>: 
   <span class="simpara">
    До PHP 8.4.0 запрещалось переключать файбер <a href="language.oop5.decon.php#language.oop5.decon.destructor" class="link">в деструкторе</a> объекта.
   </span>
  </p></blockquote>

  <div class="example" id="language.fiber.example.basic">
   <p><strong>Пример #1 Стандартный пример работы с файбером</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /><br />$fiber </span><span style="color: #007700">= new </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">(function (): </span><span style="color: #0000BB">void </span><span style="color: #007700">{<br />    </span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">Fiber</span><span style="color: #007700">::</span><span style="color: #0000BB">suspend</span><span style="color: #007700">(</span><span style="color: #DD0000">'fiber'</span><span style="color: #007700">);<br />    echo </span><span style="color: #DD0000">"Значение возобновлённого файбера: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$value </span><span style="color: #007700">= </span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">start</span><span style="color: #007700">();<br /><br />echo </span><span style="color: #DD0000">"Значение приостановленного файбера: "</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">, </span><span style="color: #0000BB">PHP_EOL</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">$fiber</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">resume</span><span style="color: #007700">(</span><span style="color: #DD0000">'test'</span><span style="color: #007700">);<br /><br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   
<div class="example-contents"><p>
 Результат выполнения приведённого примера:
</p></div>

   <div class="example-contents screen">
<div class="cdata"><pre>
Значение приостановленного файбера: fiber
Значение возобновлённого файбера: test
</pre></div>
   </div>
  </div>

 </div>

</div>
<?php manual_footer($setup); ?>